#!/usr/bin/python
import sys

inf = open(sys.argv[1], "r")
ouf = open(sys.argv[2], "r")
anf = open(sys.argv[3], "r")

n = str(int(inf.readline().strip()))
orig_n = n
operation_count = int(ouf.readline().strip())
operations = ouf.readline().strip()

if len(operations) != operation_count:
    sys.stderr.write("bad len\n")
    sys.exit(2)
if len(operations) > 10000:
    sys.stderr.write("two long\n")
    sys.exit(2)

sys.stderr.write("{} '{}'\n".format(operation_count, operations))

for c in operations:
    n = str(int(n))
    sys.stderr.write("{}\n".format(n))
    if c == '1':
        n = str(int(n)*2)
    elif c == '2':
        if int(n) % 2 != 0:
            sys.stderr.write("wrong '2'\n")
            sys.exit(1)
        n = str(int(n)//2)
    elif c == '3':
        if len(n) % 2 != 0:
            sys.stderr.write("wrong '3'\n")
            sys.exit(1)
        n = n[:len(n) // 2]
    elif c == '4':
        if len(n) % 2 != 0:
            sys.stderr.write("wrong '4'\n")
            sys.exit(1)
        n = n[len(n) // 2:]
    elif c == '5':
        if len(n) % 2 != 0:
            sys.stderr.write("wrong '5'\n")
            sys.exit(1)
        t = n[:len(n) // 2]
        n = t + t 
    elif c == '6':
        if len(n) % 2 != 0:
            sys.stderr.write("wrong '6'\n")
            sys.exit(1)
        t = n[len(n) // 2:]
        n = t + t
    else:
        sys.stderr.write("wrong operation\n")
        sys.exit(1)

print(n)
if int(n) != 1:
    sys.stderr.write("bad result\n")
    sys.exit(1)

s = set()

try:
    with open("/home/judges/000199/problems/operations/log/{0}.txt".format(orig_n), "r") as f :
        lines = f.readlines()
        s = set([elem for elem in map(int, [item.strip() for item in lines])])
except OSError as e:
    pass

if operation_count not in s:
    with open("/home/judges/000199/problems/operations/log/{0}.txt".format(orig_n), "a") as f:
        f.write(str(operation_count) + "\n")
sys.exit(0)
