#include <cstdint>
#include <iostream>

using namespace std; 

uint64_t encode(uint64_t g) 
{
    return g ^ (g >> 1);
}

uint64_t decode(uint64_t g) 
{
    uint64_t b;
    for (b = 0; g; g >>= 1) {
      b ^= g;
    }
    return b;
}

int main() {
    uint64_t a;
    cin >> a;
    
    cout << encode(decode(a) - 1) << std::endl;
}
